#include "buffer.hh"
#include <algorithm>

void buffer<char>::append(const char *const ptr)
{
	append(ptr, strlen(ptr));
}

bool buffer<char>::readline(virtual_buffer<char>& alinedst, const virtual_buffer<char>& rl_ending)
{
	char chr = *rl_ending.data;
	const char *moreend = rl_ending.data + 1;
	size_t morelen = rl_ending.tail - 1;

	virtual_buffer<char> linedst(*this);
	linedst.tail -= rl_ending.tail - 1;

	while (!linedst.is_empty()) {
		const char *p = (const char *)memchr(linedst.get_head_ptr(), chr, linedst.count_elements_left());
		if (!p)
			return false;

		if (!memcmp(p + 1, moreend, morelen)) {
			linedst.tail = p - linedst.data;
			head += linedst.tail + rl_ending.tail;
			alinedst = linedst;
			return true;
		}

		linedst.head = p + 1 - linedst.data;
	}

	return false;
}

