#!/usr/bin/perl -w
use strict;
use Term::ANSIColor qw(:constants);

while(<>) {
	chomp;
	if (m/^([0-9]+\.[0-9]{6})( .*)$/) {
		my ($stamp, $line) = ($1, $2);
		my $rst = RESET;
		my $fdcolor = RED;
		my $ipcolor = GREEN;
		$line =~ s/ (\[[0-9,]+\])/ $fdcolor$1$rst/g;
		$line =~ s/\b([0-9A-F]{8}):([0-9]{1,5})\b/$ipcolor$1:$2$rst/g;
		print YELLOW, $stamp, RESET, $line, "\n";
	} elsif (m/^([^(]*)\(([^+]*)\+(0x[0-9a-fA-F]*)\)\[(0x[0-9a-fA-F]*)\]$/) {
		my ($file, $func, $offs, $addr) = ($1, $2, eval($3), eval($4));
		printf '[%s0x%08X%s] %s%s%s+%s0x%x%s (%s%s%s)'."\n", RED, $addr, RESET,
			BOLD, $func, RESET, GREEN, $offs, RESET, BLUE, $file, RESET;
	} else {
		print "$_\n";
	}
}
