#include "eventwrap.hh"
#include "logger.hh"
#include <iostream>
#include <iomanip>
#include <execinfo.h>
#include <stdio.h>
using namespace std;

void dump_backtrace(const void *self, const char *msg, int skip)
{
	logger	<< timestamp << " [" << self << "]: " << msg << endl;

	void *bt[100];
	void **p = bt;
	size_t btlen = backtrace(bt, sizeof(bt)/sizeof(*bt));

	if (btlen > ++skip) {
		p += skip;
		btlen -= skip;
	}

	backtrace_symbols_fd(p, btlen, 2);
}

event::~event()
{
	del();
}

void event::dump_me(const char *msg) const
{
	char buf[1000];
	snprintf(buf, sizeof(buf), "%d/0x%02x %s", ev.ev_fd, ev.ev_flags, msg);
	dump_backtrace(this, buf, 1);
}

void event::call_handler(int fd, short int evflags, void *arg)
{
	event *ev = static_cast<event *>(arg);
	ev->handle(fd, evflags);
}

class libevent_initializer
{
public:
	libevent_initializer() { __ev::event_init(); }
};

static libevent_initializer libevent_init;
